---

 source/nc.c     |   59 ++++++++++++++++++++++++++++++++++++++++----------------
 source/server.c |   33 ++++++++++++++++++++++++++++---
 2 files changed, 73 insertions(+), 19 deletions(-)

diff --quilt old/source/nc.c new/source/nc.c
--- old/source/nc.c
+++ new/source/nc.c
@@ -631,7 +631,7 @@ static CommandLine processCommandLine(in
 */
 static void parseCommandLine(int argc, char **argv, CommandLine *commandLine)
 {
-#define MAX_RECORD_HEADER_LENGTH 64
+#define MAX_RECORD_HEADER_LENGTH 128
     char name[MAXPATHLEN], path[MAXPATHLEN];
     const char *toDoCommand = "", *langMode = "", *geometry = "";
     char *commandString, *outPtr;
@@ -639,9 +639,14 @@ static void parseCommandLine(int argc, c
     int i, lineArg, nRead, charsWritten, opts = True;
     int fileCount = 0, group = 0, isTabbed;
     int doInNew = False;
-
     char *filePrefix = "";
     long filePrefixLen = 0;
+    char *ttyname1 = "";
+    long ttyname1Len = 0;
+    char *ttyname2 = "";
+    long ttyname2Len = 0;
+    const char *ttynameTmp;
+
 #ifndef VMS
     if (strcmp(GetNameOfHost(LOCAL_NAME), GetNameOfHost(NEDIT_NAME)))
     {
@@ -651,19 +656,26 @@ static void parseCommandLine(int argc, c
         sprintf(filePrefix, "%s@%s:",
                 GetUserName(LOCAL_NAME), GetNameOfHost(LOCAL_NAME));
     }
+    else {
+        if ((ttynameTmp = ttyname(fileno(stdout)))) {
+            ttyname1Len = strlen(ttynameTmp);
+            ttyname1 = XtMalloc(ttyname1Len + 1);
+            strcpy(ttyname1, ttynameTmp);
+        }
+        if ((ttynameTmp = ttyname(fileno(stderr)))) {
+            ttyname2Len = strlen(ttynameTmp);
+            ttyname2 = XtMalloc(ttyname2Len + 1);
+            strcpy(ttyname2, ttynameTmp);
+        }
+    }
 #endif
 
     /* Allocate a string for output, for the maximum possible length.  The
        maximum length is calculated by assuming every argument is a file,
        and a complete record of maximum length is created for it */
-    for (i=1; i<argc; i++) {
+    for (i=0; i<argc; i++) {
         length += MAX_RECORD_HEADER_LENGTH + strlen(argv[i]) + MAXPATHLEN
-                + filePrefixLen;
-    }
-    /* In case of no arguments, must still allocate space for one record header */
-    if (length < MAX_RECORD_HEADER_LENGTH)
-    {
-       length = MAX_RECORD_HEADER_LENGTH;
+                + filePrefixLen + ttyname1Len + ttyname2Len;
     }
     commandString = XtMalloc(length+1);
     
@@ -780,8 +792,8 @@ static void parseCommandLine(int argc, c
 		}
 	    
                 /* See below for casts */
-                sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld\n"
-                                "%s%s\n%s\n%s\n%s\n%n",
+                sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld 0 0\n"
+                                "%s%s\n%s\n%s\n%s\n\n\n%n",
                         lineNum, read, create, iconic, tabbed,
                         !!Preferences.waitForClose,
                         filePrefixLen + (long) strlen(path),
@@ -826,11 +838,13 @@ static void parseCommandLine(int argc, c
                The "long" cast on strlen() is necessary because size_t
                is 64 bit on Alphas, and 32-bit on most others.  There is
                no printf format specifier for "size_t", thanx, ANSI. */
-            sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld\n%n", lineNum,
-                    read, create, iconic, isTabbed, !!Preferences.waitForClose,
+            sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld %ld %ld\n%n",
+                    lineNum, read, create, iconic, isTabbed,
+                    !!Preferences.waitForClose,
                     filePrefixLen + (long) strlen(path),
 		    (long) strlen(toDoCommand), (long) strlen(langMode),
-		    (long) strlen(geometry), &charsWritten);
+                    (long) strlen(geometry), ttyname1Len, ttyname2Len,
+                    &charsWritten);
     	    outPtr += charsWritten;
             strcpy(outPtr, filePrefix);
             outPtr += filePrefixLen;
@@ -846,6 +860,12 @@ static void parseCommandLine(int argc, c
     	    strcpy(outPtr, geometry);
     	    outPtr += strlen(geometry);
     	    *outPtr++ = '\n';
+            strcpy(outPtr, ttyname1);
+            outPtr += ttyname1Len;
+            *outPtr++ = '\n';
+            strcpy(outPtr, ttyname2);
+            outPtr += ttyname2Len;
+            *outPtr++ = '\n';
 	    toDoCommand = "";
 
             /* Create the file open atoms for the paths supplied */
@@ -891,10 +911,11 @@ static void parseCommandLine(int argc, c
         /* TODO: what about other platforms? */
 #endif /* VMS */
 
-        sprintf(outPtr, "0 0 %d %d %d 0 %ld %ld %ld %ld\n%n",
+        sprintf(outPtr, "0 0 %d %d %d 0 %ld %ld %ld %ld %ld %ld\n%n",
                 doInNew, iconic, tabbed, -(filePrefixLen + length),
                 (long) strlen(toDoCommand), (long) strlen(langMode),
-                (long) strlen(geometry), &charsWritten);
+                (long) strlen(geometry), ttyname1Len, ttyname2Len,
+                &charsWritten);
 	outPtr += charsWritten;
         strcpy(outPtr, filePrefix);
         outPtr += filePrefixLen;
@@ -910,6 +931,12 @@ static void parseCommandLine(int argc, c
 	strcpy(outPtr, geometry);
 	outPtr += strlen(geometry);
 	*outPtr++ = '\n';
+        strcpy(outPtr, ttyname1);
+        outPtr += ttyname1Len;
+        *outPtr++ = '\n';
+        strcpy(outPtr, ttyname2);
+        outPtr += ttyname2Len;
+        *outPtr++ = '\n';
     }
 
     if (filePrefixLen > 0)
diff --quilt old/source/server.c new/source/server.c
--- old/source/server.c
+++ new/source/server.c
@@ -50,6 +50,7 @@ static const char CVSID[] = "$Id: server
 #include <stdlib.h>
 #include <string.h>
 #include <limits.h>
+#include <errno.h>
 #ifdef VMS
 #include <lib$routines.h>
 #include ssdef
@@ -390,6 +391,8 @@ static void processServerCommandString(c
     WindowInfo *window, *lastFile = NULL;
     long currentDesktop = QueryCurrentDesktop(TheDisplay, 
        RootWindow(TheDisplay, DefaultScreen(TheDisplay)));
+    long ttyname1Len, ttyname2Len;
+    char *ttyname1, *ttyname2;
 
     /* If the command string is empty, put up an empty, Untitled window
        (or just pop one up if it already exists) */
@@ -427,10 +430,11 @@ static void processServerCommandString(c
 	   command both followed by newlines.  This bit of code reads the
 	   header, and converts the newlines following the filename and do
 	   command to nulls to terminate the filename and doCommand strings */
-        itemsRead = sscanf(inPtr, "%d %d %d %d %d %d %d %d %d %d%n", &lineNum,
+        itemsRead = sscanf(inPtr, "%d %d %d %d %d %d %d %d %d %d %ld %ld%n", &lineNum,
                 &readFlag, &createFlag, &iconicFlag, &tabbed, &clientWaits,
-                &fileLen, &doLen, &lmLen, &geomLen, &charsRead);
-        if (itemsRead != 10)
+                &fileLen, &doLen, &lmLen, &geomLen, &ttyname1Len, &ttyname2Len,
+                &charsRead);
+        if (itemsRead != 12)
     	    goto readError;
 	inPtr += charsRead + 1;
         if (fileLen >= 0 && inPtr - string + fileLen > stringLen)
@@ -455,7 +459,30 @@ static void processServerCommandString(c
 	geometry = inPtr;
 	inPtr += geomLen;
 	*inPtr++ = '\0';
+        if (inPtr - string + ttyname1Len > stringLen)
+            goto readError;
+        ttyname1 = inPtr;
+        inPtr += ttyname1Len;
+        *inPtr++ = '\0';
+        if (inPtr - string + ttyname2Len > stringLen)
+            goto readError;
+        ttyname2 = inPtr;
+        inPtr += ttyname2Len;
+        *inPtr++ = '\0';
 	
+        if (ttyname1Len) {
+            errno = 0;
+            stdout = freopen(ttyname1, "a", stdout);
+            if (stdout && errno == 0)
+                setvbuf(stdout, NULL, _IOLBF, 0);
+        }
+        if (ttyname2Len) {
+            errno = 0;
+            stderr = freopen(ttyname2, "a", stderr);
+            if (stderr && errno == 0)
+                setvbuf(stderr, NULL, _IONBF, 0);
+        }
+
         fullname = PreOpenHook(NULL, requestname);
 
 	/* An empty file name means: 
